{$i+}{$r+}{$q+}{$s+}
const
 MAX_N = 1000;
 INPUT_FILE = 'BUSSID.SIS';
 OUTPUT_FILE ='BUSSID.VAL';

var
  primeCount: integer;
  primes: array[1..MAX_N] of integer;
  counter: array[1..MAX_N] of integer;
  stationCount: integer;
  stations: array[1..MAX_N] of string[20];
  nextStation: array[1..MAX_N] of integer;
  markers: array[1..MAX_N] of integer;

procedure preparePrimes;
var
 l, i, limit: longint;
 ok: boolean;
begin
 primeCount := 0;

 for l:= 2 to MAX_N do
 begin
  limit:= trunc(sqrt(l));

  ok:= true;
  for i:=1 to primeCount do
  begin
   if (primes[i] > limit) then break;
   if (l mod primes[i] = 0) then
   begin
    ok:= false;
    break;
   end;
  end;

  if ok then
  begin
   inc(primeCount);
   primes[primeCount]:= l;
  end;
 end;

 for l:=1 to MAX_N do counter[l]:= 0;
end;

procedure addNumber(number:longint);
var
 l, c: integer;
begin
 for l:=1 to primeCount do
 begin
  if (primes[l] > number) then break;

  c:=0;
  while (number > 0) and (number mod primes[l] = 0) do
  begin
   inc(c);
   number:= number div primes[l];
  end;

  if (c > counter[l]) then counter[l]:= c;
 end;
end;

function buildLCM:longint;
var
 i, j: integer;
 result: longint;
begin
 result:= 1;

 for i:=1 to primeCount do
  for j:=1 to counter[i] do
   result:= result * primes[i];

 buildLCM:= result;
end;

procedure readData;
var
 f:text;
 l,i,j:integer;
 temp:string;
begin
 assign(f, INPUT_FILE);
 reset(f);
 readln(f, stationCount);

 for l:=1 to stationCount do
 begin
  readln(f, temp);
  stations[l]:= copy(temp, 1, Pos(' ', temp) - 1);
  markers[l]:= 0;
 end;

 reset(f);
 readln(f, stationCount);

 for l:=1 to stationCount do
 begin
  readln(f, temp);
  temp:=copy(temp, pos(' ', temp) + 1, length(temp) - pos(' ', temp));

  i:=1;
  while i <= stationCount do
  begin
   if (temp = stations[i]) then break;
   inc(i);
  end;

  if (i > stationCount) then
  begin
   writeln('Bad input file!');
   halt;
  end;

  nextStation[l]:=i;
  markers[i]:= 1;
 end;

 for l:=1 to stationCount do
  if markers[l] = 0 then
  begin
   writeln('Bad input file!');
   halt;
  end;

 close(f);
end;

procedure traverse(curPos, len: integer);
begin
 if (markers[curPos] <> 0) then
 begin
  addNumber(len);
  exit;
 end;

 markers[curPos]:= 1;

 traverse(nextStation[curPos], len + 1);
end;

procedure processData;
var l: integer;
begin
 for l:=1 to stationCount do
  markers[l]:= 0;

 for l:= 1 to stationCount do
  if (markers[l] = 0) then traverse(l, 0);
end;

procedure writeData;
var
 f:text;
begin
 assign(f, OUTPUT_FILE);
 rewrite(f);
 writeln(f, buildLCM);
 close(f);
end;

begin
 preparePrimes;
 readData;
 processData;
 writeData;
end.